 #include <X11/Xlib.h>
 #include <stdio.h>
 #include <stdlib.h>
 #define LEFT_BORDER 400
 #define DOWN_BORDER 300
 #define x0 200
 #define y0 100
 #define LENGTH 50


int read_KeyPress (XEvent *eventp, unsigned int *xf,
                   unsigned int  *yf, unsigned int *mv, char *plusminus)
{
    XKeyEvent *e = (XKeyEvent *) eventp;
    switch (e->keycode) { //  Что значит -> ?
        case 111: //up
              if ((*yf) != 0)
              {
                  yf[*mv]=*yf;
                  xf[*mv]=*xf;
                  (*yf)--;
                  switch (*mv)
                  {
                      case LENGTH: {*mv=1; *plusminus=1;}
                      case 1: {*mv=LENGTH; *plusminus=-1;}
                      default: *mv=*mv+*plusminus;
                  }
              }
              break;
        case 116: //down
              if ((*yf) != DOWN_BORDER-1)
              {
                  yf[*mv]=*yf;
                  xf[*mv]=*xf;
                  (*yf)++;
                  switch (*mv)
                  {
                      case LENGTH: {*mv=1; *plusminus=1;}
                      case 1: {*mv=LENGTH; *plusminus=-1;}
                      default: *mv=*mv+*plusminus;
                  }
              }
              break;
        case 113: //left
              if ((*xf) != 0)
              {
                  yf[*mv]=*yf;
                  xf[*mv]=*xf;
                  (*xf)--;
                  switch (*mv)
                  {
                      case LENGTH: {*mv=1; *plusminus=1;}
                      case 1: {*mv=LENGTH; *plusminus=-1;}
                      default: *mv=*mv+*plusminus;
                  }
              }
              break;
        case 114: //right
              if ((*xf) != LEFT_BORDER-1)
              {
                  yf[*mv]=*yf;
                  xf[*mv]=*xf;
                  (*xf)++;
                  switch (*mv)
                  {
                      case LENGTH: {*mv=1; *plusminus=1;}
                      case 1: {*mv=LENGTH; *plusminus=-1;}
                      default: *mv = *mv+*plusminus;
                  }
              }
              break;
    }
    return 0;
}


 
int main(void) 
{
    unsigned int x[LENGTH], y[LENGTH];
    Display *d;
    Window w;
    unsigned int s;
    unsigned int mv; //переброс пикселей из зада вперед
    unsigned int count;
    char plusminus;
    XEvent e;
    
                        /* open connection with the server */
   d = XOpenDisplay(NULL);
   if (d == NULL) {
     fprintf(stderr, "Cannot open display\n");
     exit(1);
   }
 
   s = DefaultScreen(d);
 
                        /* create window */
   w = XCreateSimpleWindow(d, RootWindow(d, s), 10, 10, LEFT_BORDER, DOWN_BORDER, 1,
                           BlackPixel(d, s), WhitePixel(d, s));
 
                        /* select kind of events we are interested in */
   XSelectInput(d, w, ExposureMask | KeyPressMask);
 
                        /* map (show) the window */
   XMapWindow(d, w);
   mv=LENGTH;
   count = 2;
   do
   {
       x[count]=1+x0-count;
       y[count]=y0;
       count++;
   }
   while (count != (LENGTH));
   mv=1;
   x[0]=x0;
   y[0]=y0;
   x[1]=x0-LENGTH+1;
   y[1]=y0;
                           /* event loop */
   while (1)
    {
        XNextEvent(d, &e);
        if (e.type == Expose)
        {
            count=0;
            XSetForeground(d, DefaultGC(d, s), 0x000000);
            //рисуем змею
            do
                {
                XDrawPoint(d, w, DefaultGC(d, s), x[count], y[count]);
                count++;
            }
            while (count != (LENGTH));
        }    
        if (e.type == KeyPress)
        {
            XSetForeground(d, DefaultGC(d, s), 0xFFFFFF);
            XDrawPoint(d, w, DefaultGC(d, s), x[mv], y[mv]); //закрашиваем белым то место, где был зад
            read_KeyPress (&e, x, y, &mv, &plusminus);
            XSetForeground(d, DefaultGC(d, s), 0x000000);
            XDrawPoint(d, w, DefaultGC(d, s), x[0], y[0]);
        }
         
    }
    return 0;
}